#include "Keyboard.h"
#include "Mouse.h"
#include "JC_Button.h"
#include "MD_REncoder.h"

// ######################### JOYSTICK
#define joyX A0
#define joyY A1
int JX;
int JY;
int J = 0;
bool jpress = false;
bool JUP=false;
// ######################### ROTARY ENCODERS

MD_REncoder R1 = MD_REncoder(2, 3); // dt-clk
const byte R1swPin= 4; // R1BTN

MD_REncoder R2 = MD_REncoder(5, 6);
const byte R2swPin= 7; // R1BTN

int spin = 1;
int slider = 50;

// ######################### BUTTONS

const byte B1Pin(8);
const byte B2Pin(9);
const byte B3Pin(10);
const byte B4Pin(1); //BTN4
const byte JbtnPin(0); //BTN JOYSTICK

Button Btn1(B1Pin, 50, false, true);
Button Btn2(B2Pin, 50, false, true);
Button Btn3(B3Pin, 50, false, true);
Button Btn4(B4Pin, 50, false, true);  // MODE BUTTON
int ACTIVE_BUTTON;
bool MODE_BUTTON;

Button R1btn(R1swPin, 50, false, true); // R1BTN
Button R2btn(R2swPin, 50, false, true); // R2BTN
Button Jbtn(JbtnPin, 50, false, true);


// ######################### RGB LED

int RED= 11;
int GREEN = 12;
int BLUE = 13;

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> SETUP

void setup() {

  // ENCODERS

  R1.begin();
  R2.begin();
  

  // BUTTONS

  Btn1.begin(); Btn2.begin(); Btn3.begin(); Btn4.begin();
  Jbtn.begin();
  R1btn.begin(); R2btn.begin();
  
  ACTIVE_BUTTON=0;
  MODE_BUTTON=false;

  // JOYSTICK
  
  
  // LED

  pinMode(RED, OUTPUT);
  pinMode(GREEN, OUTPUT);
  pinMode(BLUE, OUTPUT);

  Mouse.begin();
  Keyboard.begin();
  //Serial.begin(9600);
}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START LOOP
void loop() {

  // __________________JOYSTICKS

  JX = analogRead(joyX);
  JY = analogRead(joyY);

if( JY>550)
{
  Keyboard.press(KEY_DOWN_ARROW);delay(slider);Keyboard.releaseAll();
}
else if( JY<450)
{
  Keyboard.press(KEY_UP_ARROW);delay(slider);Keyboard.releaseAll();
}
if( JX>550)
{
  Keyboard.press(KEY_RIGHT_ARROW);delay(slider);Keyboard.releaseAll();
}
else if( JX<450)
{
  Keyboard.press(KEY_LEFT_ARROW);delay(slider);Keyboard.releaseAll();
}

  // _______________________________________ ENCODERS
  

R1foo();
R2foo();


  // __________________________________ BUTTONS
  //digitalWrite(LED_BUILTIN, state);
  Btn1.read();Btn2.read();Btn3.read();Btn4.read();
  R1btn.read();R2btn.read();

    if(R1btn.wasReleased()) 
  { 
      if (spin==1) {spin=10; slider = 1;}
      else if (spin==10) {spin=1; slider = 50;}
  }

  
  if(Btn1.wasReleased()) 
  {
    if (ACTIVE_BUTTON != 1){
      ACTIVE_BUTTON = 1;
      Keyboard.releaseAll(); 
      Keyboard.press(KEY_LEFT_CTRL);  
      }
    else if (ACTIVE_BUTTON == 1){
      ACTIVE_BUTTON = 0;
      Keyboard.releaseAll(); 
      }
  }
  if(Btn2.wasReleased())
  {
    if (ACTIVE_BUTTON != 2){
      ACTIVE_BUTTON = 2;
      Keyboard.releaseAll(); 
      Keyboard.press(KEY_LEFT_ALT); 
      }
    else if (ACTIVE_BUTTON == 2){
      ACTIVE_BUTTON = 0;
      Keyboard.releaseAll();
      }
  }
  if(Btn3.wasReleased()) 
  {
    if (ACTIVE_BUTTON != 3){
      ACTIVE_BUTTON = 3;
      Keyboard.releaseAll(); 
      Keyboard.press(KEY_LEFT_SHIFT);
      }
    else if (ACTIVE_BUTTON == 3){
      ACTIVE_BUTTON = 0;
      Keyboard.releaseAll();
      }
  }
  
  if(Btn4.wasReleased()) 
  {
    if (ACTIVE_BUTTON != 4){
      ACTIVE_BUTTON = 4;
      Keyboard.releaseAll(); 

      }
    else if (ACTIVE_BUTTON == 4){
      ACTIVE_BUTTON = 0;
      Keyboard.releaseAll(); 
      }

      
  }

switch (ACTIVE_BUTTON)
  {
    case 0:
      LEDsw(LOW, LOW, LOW); 
      break;
    case 1:
      LEDsw(HIGH, LOW, LOW);
      break;
    case 2:
      LEDsw(LOW, HIGH, LOW);
      break;
    case 3:
      LEDsw(LOW, LOW, HIGH);
      break;
    case 4:
      LEDsw(HIGH, LOW, HIGH);
      break;
  }

  
} // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> END LOOP


//################################ FUNCTIONS

// LED MANAGER

void LEDsw(int r,int g,int b) {
  digitalWrite(RED, r);
  digitalWrite(GREEN, g);
  digitalWrite(BLUE, b);
}


// ENCODER 

void R1foo()
{
  uint8_t R1val = R1.read();
  
 if (R1val) 
 {
   if (ACTIVE_BUTTON==4) 
   {R1val == DIR_CW ? Keyboard.print(".") : Keyboard.print(",");}
   else
   {R1val == DIR_CW ? Mouse.move(0, 0, spin) : Mouse.move(0, 0, -spin);}
 }


}

void R2foo()
{
  uint8_t R2val = R2.read();
  
 if (R2val) 
 {
  if (R2val== DIR_CW)
  { 
    Keyboard.press(KEY_LEFT_CTRL);delay(70);Mouse.move(0, 0, -spin);Keyboard.release(KEY_LEFT_CTRL);
  }
  else
  {
    Keyboard.press(KEY_LEFT_CTRL);delay(70);Mouse.move(0, 0, spin);Keyboard.release(KEY_LEFT_CTRL);
  }
  
   //R2val== DIR_CW ? Keyboard.print(".") : Keyboard.print(","); 
}
}
